// Copyright (C) 2004, 2014 Christian Jaekl

package net.jaekl.qd.xml;

import java.util.ArrayList;

public class MissingInfoException extends XmlParseException
{
	private static final long serialVersionUID = 1L;

	String m_tagName;
	ArrayList<String> m_missingAttributes;
	ArrayList<String> m_missingChildTags;

	public MissingInfoException(String tagName) {
		super();
		m_tagName = tagName;
		m_missingAttributes = new ArrayList<String>();
		m_missingChildTags = new ArrayList<String>();
	}

	public void addMissingAttribute(String name) {
		m_missingAttributes.add(name);
	}

	public void addMissingChild(String name) {
		m_missingChildTags.add(name);
	}

	public String getTagName() { return m_tagName; }
	
	@Override
	public String getMessage() {
		StringBuilder sb = new StringBuilder();
		
		sb.append("Tag:  \"" + getTagName() + "\"");
		
		for (String attr : m_missingAttributes) {
			sb.append("\n  Attribute:  \"" + attr + "\"");
		}
		
		for (String child : m_missingChildTags) {
			sb.append("\n  Child tag:  \"" + child + "\"");
		}
		return sb.toString();
	}
}
