package net.jaekl.cfb.analyze;

import static org.junit.Assert.*;

import java.io.File;

import org.junit.Test;

public class AnalyzerTest {

	@Test
	public void testOutputWorkFile() {
		final String[][] DATA = {
				// findBugsDir, workDir, FBP,        expectedOutputXml
				{ "foo",        "bar",   "baz.fbp",  "bar" + File.separator + "baz.xml" },
				{ 
					File.separator + "findbugs-3.01",
					"." + File.separator + "work",
					"project.fbp",
					"." + File.separator + "work" + File.separator + "project.xml"
				}
			};
		
		for (String[] datum : DATA) {
			File findBugsDir = new File(datum[0]);
			File workDir     = new File(datum[1]);
			File fbp         = new File(datum[2]);
			File expected    = new File(datum[3]);

			Analyzer analyzer = new Analyzer(findBugsDir);
			File actual = analyzer.outputWorkFile(workDir, fbp);
			assertEquals(expected.getAbsolutePath(), actual.getAbsolutePath());
		}
	}

}
