package net.jaekl.qd.xml;

import org.junit.Assert;

import org.junit.Test;

public class MissingInfoExceptionTest {

	@Test
	public void test_getMessage_withSimpleTag() {
		final String TAG = "TagNameGoesHere";
		MissingInfoException mie = new MissingInfoException(TAG);
		String expected = "Tag:  \"" + TAG + "\"";
		String actual = mie.getMessage();
		Assert.assertTrue(actual.contains(expected));
	}
	
	@Test
	public void test_getMessage_withAttributesAndChildren() {
		final String AUGUSTUS = "Augustus";
		final String NOMEN = "nomen";
		final String COGNOMEN = "cognomen";
		final String TIBERIUS = "Tiberius";
		final String JULIA = "Julia";
		
		MissingInfoException mie = new MissingInfoException(AUGUSTUS);
		mie.addMissingAttribute(NOMEN);
		mie.addMissingAttribute(COGNOMEN);
		mie.addMissingChild(TIBERIUS);
		mie.addMissingChild(JULIA);
		
		String actual = mie.getMessage();
		Assert.assertTrue(actual.contains("Tag:  \"" + AUGUSTUS + "\""));
		Assert.assertTrue(actual.contains("Attribute:  \"" + NOMEN + "\""));
		Assert.assertTrue(actual.contains("Attribute:  \"" + COGNOMEN + "\""));
		Assert.assertTrue(actual.contains("Child tag:  \"" + TIBERIUS + "\""));
		Assert.assertTrue(actual.contains("Child tag:  \"" + JULIA + "\""));
	}

}
